; File:     Printer6.asm
;---------------------------------------
   .586
    .model  flat, stdcall
    option  casemap :none
; 
    include \masm32\include\windows.inc
    include \masm32\macros\macros.asm

    include \masm32\include\kernel32.inc
    include \masm32\include\user32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\comdlg32.inc            ; printer
    
;----------------------------------------------
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\comdlg32.lib             ; printer
    
; 
WinMain         proto   :DWORD,:DWORD,:DWORD,:DWORD
CmdProc         proto   :DWORD,:DWORD,:DWORD,:DWORD 
WndProcA        proto   :DWORD,:DWORD,:DWORD,:DWORD

GetPrinterDC    proto   :DWORD,:DWORD
TextPrint       proto   :DWORD,:DWORD,:DWORD
CreateFontX     proto   :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

; ##############################################################################################
.const
MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN     
MAIN_EXTSTYLE    equ 300h

;----------- Menus ---------------------
IDM_Menu1        equ 1001
IDM_Menu2        equ 1002
IDM_Menu3        equ 1003
;---------------------------------------

$ECRAWIDTH$         equ 1268              ; largura do exr
$ECRAHEIGHT$        equ 966               ; altura do ecr

;  Data Section 
.data
_MsgErro    db 'Erro', 0
_MsgTit1    db 'Erro', 0

_MsgTit2    db 'Teste', 0
_MsgTest    db 'Fonte Seleccionada', 0
;---------------------------------------
_hpdc        dd 0
_hpFont      dd 0

;---------------------------------------
_FontMSSSerif   db 'MS Sans Serif',0

_DocTitle    db 'Documento',0

_mColumns    dd 120             ;Number of columns  160
_mLines      dd 50              ;Number of lines    84
_WidthCharX  dd ?
_HeightCharY dd ?
;.....................................................................................
             dd 120
_TxtToPrint0 db 'Print this text aaaaaaaaaabbbbbbbbbbccccccccccddddddddddeeee'
             db 'Print this text eeeeeeffffffffffgggggggggghhhhhhhhhh12345678'
             dd 26
_TxtToPrint1 db 'Print this text 1 - Line 3'
             dd 31
_TxtToPrint2 db 'Print this text too 2 - Line 20'
             dd 31
_TxtToPrint3 db 'Print this text too 3 - Line 40'
             dd 31
_TxtToPrint4 db 'Print this text too 4 - Line 50'
;....................................................................................
_Text        db '1 - This is the text to be printed .......'
             db '2 - this text is null terminated bl bl bl.....'
             db '3 - bl bl ...this text is null terminated bl bl bl.....'
             db '4 - bl bl ...this text is null terminated bl bl bl.....'
             db '5 - bl bl ...this text is null terminated bl bl bl.....'
             db '6 - bl bl ...this text is null terminated bl bl bl.....'
             db '7 - bl bl ...this text is null terminated bl bl bl.....'
             db '8 - bl bl ...this text is null terminated bl bl bl.....'
             db 0                                                           ; null terminator             
;....................................................................................

_MenuName    db 'Menu',0               ; Definido em rsrc.rc
_hWnd        dd 0

;----------------------------------------
_ClassName   db 'WinClass',0
_WindowName  db 'Print Text',0
;  Data? Section 
.data?
;---------------------------------------
_hInstance   dd ?
;_hdc         dd ?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>

_lf          LOGFONT <?>
_di          DOCINFO <?>
_pd          PRINTDLG <?>
_tm          TEXTMETRIC  <?>
_rc          RECT <?>

_PosPrnX     dd ?            ; posio horizontal
_PosPrnY     dd ?            ; posio vertical

_NumPixelX   dd ?
_NumPixelY   dd ?
;  Code Section 
.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     _hInstance, eax
    invoke  WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT

; ##############################################################################################
align 16
WinMain     proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC         
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
            invoke  CreateSolidBrush, 0
        	mov   _wcx.hbrBackground, eax          ; COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class
            mov    _wcx.hIcon, NULL                         ;eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx
            ;
            ; Cria a janela
            ; -------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   0, 0, 1280, 990, NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     

            invoke    GetPrinterDC, 50, 120

            invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd
            
;#############################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; 
GetPrinterDC        proc    Lin:DWORD, Col:DWORD
                    ;
                    mov     eax, Lin
                    add     eax, 4
                    mov     _mLines, eax
                    ;
                    mov     eax, Col
                    mov     _mColumns, eax
                    
                    cmp     _hpdc, 0
                    je      short @F
                    ret
                    ;
@@:                 mov     _pd.lStructSize, sizeof PRINTDLG
                    mov     _pd.Flags, PD_RETURNDC or PD_USEDEVMODECOPIES
                    mov     _pd.nCopies, 1

                    invoke  PrintDlg, addr _pd
                    cmp     eax, TRUE
                    je      short @F

                    mov     _hpdc, 0
                    ret

@@:                 mov     eax, _pd.hDC
                    mov     _hpdc, eax
                    ;
                    ; Pixeis na HORIZONTAL
                    ; --------------------
                    invoke  GetDeviceCaps, _hpdc, HORZRES
                    mov     _NumPixelX, eax
                    ;
                    ; Pixeis na VERICAL
                    ; -----------------
	              invoke  GetDeviceCaps, _hpdc, VERTRES
                    mov     _NumPixelY, eax
                    ;
                    ; para termos _mColunas ...
                    ; -------------------------
                    xor     edx, edx
                    mov     eax, _NumPixelX                    
                    div     _mColumns
                    mov     _WidthCharX, eax
                    ;
                    ; para termos _mLinhas ...
                    ; ------------------------
                    xor     edx, edx
                    mov     eax, _NumPixelY                                    
                    div     _mLines
        	        mov    _HeightCharY, eax

                    ; 
                    ; Font
                    ; 
                    mov       eax, _WidthCharX
        	        mov       edx, _HeightCharY
                    neg       edx
                    neg       eax
                    invoke    CreateFontX, addr _FontMSSSerif, edx, eax, FW_NORMAL, 0
                                        
                    jnc       short @F
                    ret
                    ;
@@:                 invoke    SelectObject, _hpdc, _hpFont

                    call      SendTeste
                    ret
GetPrinterDC        endp
; 
CreateFontX     proc    pName:DWORD, Alt:DWORD, Lgr:DWORD, Typ:DWORD, ID:DWORD

                mov     eax, Typ
                mov     _lf.lfWeight, eax
                
                mov     eax, Alt
                mov     _lf.lfHeight, eax
                mov     eax, Lgr       
                mov     _lf.lfWidth, eax
                ;
                mov     _lf.lfEscapement, 0
                mov     _lf.lfOrientation, 0
                mov     _lf.lfItalic, FALSE
                mov     _lf.lfUnderline, FALSE
                mov     _lf.lfStrikeOut, FALSE
                mov     _lf.lfCharSet, ANSI_CHARSET 
                mov     _lf.lfOutPrecision, OUT_DEFAULT_PRECIS or OUT_DEVICE_PRECIS
                mov     _lf.lfClipPrecision, CLIP_DEFAULT_PRECIS
                mov     _lf.lfQuality, PROOF_QUALITY        

                mov     al, DEFAULT_PITCH or FF_MODERN
                mov     edx, ID
                cmp     edx, 0
                je      @F
                             
                mov     al, DEFAULT_PITCH or FF_ROMAN
                cmp     edx, 1
                je      @F

                mov     al, DEFAULT_PITCH or FF_SWISS
                cmp     edx, 2
                je      @F

                mov     al, DEFAULT_PITCH or FF_SCRIPT
                cmp     edx, 3
                je      @F

                mov     al, DEFAULT_PITCH or FF_DECORATIVE
                cmp     edx, 4
                je      @F
                
                mov     al, DEFAULT_PITCH or FF_DONTCARE

@@:             mov     _lf.lfPitchAndFamily, al
                ;
                mov     edx, pName
                mov     ebx, offset _lf
                ;
@@:             movzx   eax, byte ptr [edx]                
                mov     byte ptr [ebx].LOGFONT.lfFaceName, al
                ;
                inc     edx
                inc     ebx
                ;
                or      eax, eax
                jnz     short @B

                invoke  CreateFontIndirect, addr _lf
                mov     _hpFont, eax
                ;
                cmp     eax, 0
                jne     short @F

                call    SendErro
                
                stc
                ret
                
@@:             clc
                ret
CreateFontX     endp
; 
PrintText           proc

                    cmp     _hpdc, 0
                    jne     short @F
                    ret
                    
@@:                 mov    _di.cbSize, SIZEOF _di
                    mov    _di.lpszDocName, offset _DocTitle
                    mov    _di.lpszOutput, NULL
                    mov    _di.fwType, NULL
                    ;
                    invoke  StartDoc, _hpdc, addr _di
                    cmp     eax, 0
                    jg      short @F
                    ret
                    
@@:                 invoke  StartPage, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ;
                    invoke  EndDoc, _hpdc
                    ret

                    ; 
                    ; Print Text
                    ; 
@@:                 ;invoke  TextPrint, offset _TxtToPrint0, 1, 1 
                    ;invoke  TextPrint, offset _TxtToPrint1, 3, 10
                    ;invoke  TextPrint, offset _TxtToPrint2, 20, 40
                    ;invoke  TextPrint, offset _TxtToPrint3, 40, 1
                    ;invoke  TextPrint, offset _TxtToPrint4, 50, 80                    

                    invoke  GetDeviceCaps, _hpdc, HORZRES
                    dec     eax
                    mov     _rc.right, eax

                    invoke  DrawTextEx, _hpdc, addr _Text, -1, addr _rc,
                                        DT_CALCRECT or DT_EDITCONTROL or \
                                        DT_EXPANDTABS or DT_WORDBREAK, 0

                    invoke  DrawTextEx, _hpdc, addr _Text, -1, addr _rc,
                                        DT_EDITCONTROL or DT_EXPANDTABS or DT_WORDBREAK,
                                        0
                    ;   
                    ;
                    ;
                    invoke  EndPage, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ;
                    invoke  EndDoc, _hpdc                    
                    ret
                    ;
@@:                 invoke  EndDoc, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ret
                    
@@:                 invoke   DeleteObject, _hpFont
                    ;
                    invoke   DeleteDC, _hpdc   
                    mov      _hpdc, 0
                    ret
PrintText           endp
; 
TextPrint           proc    pTxt:DWORD, Lin:DWORD, Col:DWORD

                    invoke  GetTextMetrics, _hpdc, addr _tm
                    ;
                    mov     ecx, _tm.tmHeight
                    mov     eax, Lin
                    sub     eax, 1
                    mul     ecx                 
                    mov     _PosPrnY, eax
                    ;
                    ;
                    ;
                    mov     ecx, _tm.tmAveCharWidth
                    mov     eax, Col
                    sub     eax, 1
                    mul     ecx
                    mov     _PosPrnX, eax

                    mov     ebx, pTxt
                    invoke  TextOut, _hpdc, _PosPrnX, _PosPrnY, ebx, [ebx - 4]
                    ;invoke  TextOut, _hpdc, _PosPrnX, _PosPrnY, pTxt, [pTxt - 4]                    
                    ret
TextPrint           endp
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     SWITCH  edx

                case    IDM_Menu1       ; Printer DC

                    ; 
                    ; Get Printer DC
                    ; 
                    invoke  GetPrinterDC, 50, 120

                case    IDM_Menu2       ; Print Text

                    ; 
                    ; Print Text
                    ; 
                    call    PrintText
                    
                case    IDM_Menu3       ; Close
                
                    invoke    SendMessage, _hWnd, WM_CLOSE, 0, 0

                default
                    jmp      _EndProcA
                ENDSW
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
                ;               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           

                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND
                
                jmp     _EndProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
                ;jmp     _WM_CLOSE
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     cmp     _hpdc, 0
                je      short @F
                ;
                invoke   DeleteDC, _hpdc
@@:
                invoke   DestroyWindow,  hWnd
                jmp     _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                jmp     _ExitProcA 
                
; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam                
                ret
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp    
; 
SendErro        proc
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgErro, addr _MsgTit1, MB_OK 	
                ;
                popad
                ret
SendErro        endp
; 
SendTeste       proc
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest, addr _MsgTit2, MB_OK 	
                ;
                popad
                ret
SendTeste       endp
; ##############################################################################################
    end     start

